
#ifndef NANO_TIMER_H
#define NANO_TIMER_H


float time_ms( void );


#define NANO_TIMER_NUM_HISTORY 10

class NanoTimer
{
public:

	NanoTimer();

	void start( void );
	double elapsed( void ) const;
	void stop( void );
	double average( void );

	static bool usesHighFrequ( void );
	static double frequ( void );

private:

	unsigned long long int m_time_stamp;
	double m_history[NANO_TIMER_NUM_HISTORY];
	bool m_first_time;

	static bool		M_Use_High_Frequ;
	static double	M_GHz;
	static bool		M_FrequencyChecked;

	static long long unsigned int getTimeStamp( void );
	static void checkFrequency( void );
	static double convert( unsigned long long int interval );

};

#endif

